# NOTE: Derived from /home/vfonov/src/minc-toolkit/mni-perllib/MNI/Spawn.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package MNI::Spawn;

#line 985 "/home/vfonov/src/minc-toolkit/mni-perllib/MNI/Spawn.pm (autosplit into /home/vfonov/src/build/minc-toolkit/mni-perllib/perl/auto/MNI/Spawn/gather_error.al)"
# ------------------------------ MNI Header ----------------------------------
#@NAME       : &gather_error
#@INPUT      : $pid   - process id of the now deceased child, presumed
#                       to have written its stderr to /tmp/error$pid.log
#                       (in fact, we crash 'n burn if this file is not found)
#@OUTPUT     : $dest  - (scalar or array ref) contents of stderr are put
#                       into the referenced variable
#@RETURNS    : $error - the contents of that temporary file -- all lines
#                       are concatented together, but the newlines are
#                       preserved
#@DESCRIPTION: Reads in a temporary file that was created to hold a
#              child process' stderr.
#@METHOD     : 
#@GLOBALS    : 
#@CALLERS    : spawn_redirect, spawn_capture
#@CALLS      : 
#@CREATED    : 1996/12/10, GPW (from &spawn_redirect and &spawn_capture)
#@MODIFIED   : 1997/07/08, GPW (from JobControl.pm)
#-----------------------------------------------------------------------------
sub gather_error
{
   my ($pid, $dest) = @_;
   my ($filename);

   $filename = "/tmp/error${pid}.log";

   open (ERROR, "<$filename") || 
      confess ("spawn: unable to open \"$filename\": $!");
   capture_stream (\*ERROR, $dest);
   close (ERROR);
   unlink ($filename) ||
      carp ("spawn: warning: unable to delete temporary file $filename: $!");
}  # gather_error

# end of MNI::Spawn::gather_error
1;
