# NOTE: Derived from /home/vfonov/src/minc-toolkit/mni-perllib/MNI/Spawn.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package MNI::Spawn;

#line 1020 "/home/vfonov/src/minc-toolkit/mni-perllib/MNI/Spawn.pm (autosplit into /home/vfonov/src/build/minc-toolkit/mni-perllib/perl/auto/MNI/Spawn/obituary.al)"
# ------------------------------ MNI Header ----------------------------------
#@NAME       : obituary
#@INPUT      : $status
#              $program
#              $command
#              $stdout_mode
#              $stderr_mode
#              $output
#              $error
#@OUTPUT     : 
#@RETURNS    : 
#@DESCRIPTION: Generates and mails a fairly detailed death notice to the 
#              address from the `notify' option.  (`notify' must be non-
#              empty, and `execute' must be true, for this to be done.)
#@GLOBALS    : $main::ProgramName
#@CALLERS    : check_status
#@CALLS      : 
#@CREATED    : 
#-----------------------------------------------------------------------------
sub obituary
{
   my ($self, $status, $program, $command, 
       $stdout_mode, $stderr_mode, $output, $error) = @_;

   my ($text, $cwd);

   if ($self->{notify} && $self->{execute})
   {
      $text = '';
      $cwd = getcwd();

      $text .= "$ProgramName crashed" . 
         ($program ? " while running $program" : "") . "\n";
      $text .= "from directory: $cwd\n";

      if ($command)
      {
         $command = shellquote (@$command) if ref $command;
         $text .= "full command: $command\n";
      }

      if (($stdout_mode == CAPTURE && $output) ||
          ($stderr_mode == CAPTURE && $error))
      {
         my $p = $program || "the child program";
         $output = ref ($output eq 'ARRAY') ? join ("\n", @$output) : $$output;
         $error = ref ($error eq 'ARRAY') ? join ("\n", @$error) : $$error;
         $text .= "\nHere is ${p}'s standard output:\n$output\n"
            if ($stdout_mode == CAPTURE && $output);
         $text .= "\n\nHere is ${p}'s standard error:\n$error\n"
            if ($stderr_mode == CAPTURE && $error);
      }

      open (MAIL, "|/usr/lib/sendmail $self->{notify}");

      print MAIL <<EOM;
From: $ProgramName ($ProgramName)
Subject: $ProgramName crashed while running $program

Dear $self->{notify},

$text

EOM
      close (MAIL);
   }

   $program
      ? die "$ProgramName: crashed while running $program " .
            "(termination status=$status)\n"
      : die "$ProgramName: crashed while running another program " .
            "(termination status=$status)\n";

}  # obituary   

# end of MNI::Spawn::obituary
1;
