# NOTE: Derived from /home/vfonov/src/minc-toolkit/mni-perllib/MNI/Spawn.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package MNI::Spawn;

#line 803 "/home/vfonov/src/minc-toolkit/mni-perllib/MNI/Spawn.pm (autosplit into /home/vfonov/src/build/minc-toolkit/mni-perllib/perl/auto/MNI/Spawn/output_mode.al)"
# ------------------------------ MNI Header ----------------------------------
#@NAME       : output_mode
#@INPUT      : $name - name of the option describing some output stream
#                      (for error messages)
#              $dest - the value of the option that the user supplied 
#                      (either a string [filename], reference, or one of
#                      the output mode constants)
#@OUTPUT     : 
#@RETURNS    : an output mode constant (UNTOUCHED, MERGE, REDIRECT, or CAPTURE)
#@DESCRIPTION: Generalizes a particular value of the `stdout' or `stderr'
#              options into one of the four possible things we can do
#              with an output stream (leave it untouched, merge it with 
#              stdout [stderr only], redirect it, or capture it).
#@CALLERS    : spawn
#@CALLS      : 
#@CREATED    : 1997/07/07, GPW
#@MODIFIED   : 
#-----------------------------------------------------------------------------
sub output_mode
{
   my ($name, $dest) = @_;
   my $mode;

   MODE:
   {
      if (ref $dest)
      {
         ($mode = UNTOUCHED, $dest = '', last MODE)
            if $dest == UNTOUCHED;
         ($mode = MERGE, last MODE)
            if $dest == MERGE;
         croak "spawn: $name must be a filename to redirect" 
            if $dest == REDIRECT;
         croak "spawn: $name must be a reference to capture"
            if $dest == CAPTURE;
         croak "spawn: $name must be a scalar or array reference to capture"
            unless ref $dest eq 'SCALAR' || ref $dest eq 'ARRAY';
         $mode = CAPTURE, last MODE;
      }
      else
      {
         $mode = UNTOUCHED, last MODE if (!defined $dest || $dest eq '');
         $mode = REDIRECT;
      }
   }
   ($dest, $mode);
}

# end of MNI::Spawn::output_mode
1;
