# NOTE: Derived from /home/vfonov/src/minc-toolkit/mni-perllib/MNI/Spawn.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package MNI::Spawn;

#line 165 "/home/vfonov/src/minc-toolkit/mni-perllib/MNI/Spawn.pm (autosplit into /home/vfonov/src/build/minc-toolkit/mni-perllib/perl/auto/MNI/Spawn/register_programs.al)"
# ------------------------------ MNI Header ----------------------------------
#@NAME       : register_programs
#@INPUT      : 
#@OUTPUT     : 
#@RETURNS    : 
#@DESCRIPTION: 
#@CREATED    : 1997/07/07, GPW, from FindPrograms in JobControl.pm
#@MODIFIED   : 1997/10/01, GPW: changed so $programs can be a hash ref
#-----------------------------------------------------------------------------
sub register_programs
{
   my ($self, $programs, $path) = @_;

   croak 'register_programs: $programs must be a list or hash reference'
      unless ref $programs eq 'ARRAY' || ref $programs eq 'HASH';
   croak 'register_programs: if supplied, $path must be a list reference' .
         ' or simple string'
      unless (ref $path eq 'ARRAY' || ! ref $path);

   my (@fullpaths, @warnings);

   if (ref $programs eq 'ARRAY')
   {
      @warnings = catch_warnings
         (sub
          { 
             @fullpaths = find_programs 
                ($programs, $path || $self->{search_path});
          });

      if (@fullpaths)              # all found successfully?
      {
         confess "Wrong number of full paths to go with program list"
            unless (@fullpaths == @$programs);

         map { $self->{programs}{$_} = shift @fullpaths } @$programs;
         return 1;
      }
      else
      {
         map { warn "$ProgramName: \l$_" } @warnings;
         return 0;
      }
   }
   elsif (ref $programs eq 'HASH')
   {
      my ($key, $value);
      my $errors = 0;

      carp "register_programs: \$path ignored in \$programs is a hash ref"
         if defined $path;
      while (($key, $value) = each %$programs)
      {
         unless (-x $value)
         {
            warn "$ProgramName: \"$value\" doesn't exist or not executable\n";
            $errors++;
         }
         else
         {
            $self->{programs}{$key} = $value;
         }
      }

      return ($errors == 0);
   }
}

# end of MNI::Spawn::register_programs
1;
