# NOTE: Derived from /home/vfonov/src/minc-toolkit/mni-perllib/MNI/Startup.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package MNI::Startup;

#line 571 "/home/vfonov/src/minc-toolkit/mni-perllib/MNI/Startup.pm (autosplit into /home/vfonov/src/build/minc-toolkit/mni-perllib/perl/auto/MNI/Startup/cleanup.al)"
# Now comes the chain of subroutines by which we clean up the mess made
# by the user's program in its temporary directory ($TmpDir).  There are
# really only two kinds of shutdown to worry about: normal and abnormal.
# Normal exits are triggered by running off the end of main, calling
# exit anywhere, or die anywhere outside of an eval; these are all
# handled by the "END" block -- on shutting down the script, Perl
# executes this END block, which calls cleanup; we then return to Perl's
# shutdown sequence (including possibly any other END blocks).  Abnormal
# exits are triggered by signals; we catch a generous helping of signals
# with &catch_signal, which prints a message to say what signal killed
# us, calls &cleanup (to emulate the END block), uninstalls itself, and
# sends the same signal again to ensure that our parent knows we were
# killed by a signal.

sub cleanup
{
   my ($crash) = @_;

   # Only print times if $Verbose is true (end-user control), 'cputimes'
   # option is true (programmer control), and we're not crashing (just
   # dumb luck)

   if ($Verbose && $options{cputimes} && !$crash)
   {
      my (@stop_times, @elapsed, $i, $user, $system);

      @stop_times = times;
      foreach $i (0 .. 3)
      { 
	 $elapsed[$i] = $stop_times[$i] - $start_times[$i];
      }
      $user = $elapsed[0] + $elapsed[2];
      $system = $elapsed[1] + $elapsed[3];
      print "Elapsed time in ${ProgramName} ($$) and children:\n";
      printf "%g sec (user) + %g sec (system) = %g sec (total)\n", 
	      $user, $system, $user+$system;
   }

   if ($options{cleanup} && !$KeepTmp && 
       defined $orig_tmpdir && -d $orig_tmpdir)
   {
      local $?;                         # so we don't clobber exit status!
      system 'rm', '-rf', $orig_tmpdir;
      warn "\"rm -rf $orig_tmpdir\" failed\n" if $?;
   }
}

# end of MNI::Startup::cleanup
1;
