# NOTE: Derived from /home/vfonov/src/minc-toolkit/mni-perllib/MNI/Startup.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package MNI::Startup;

#line 715 "/home/vfonov/src/minc-toolkit/mni-perllib/MNI/Startup.pm (autosplit into /home/vfonov/src/build/minc-toolkit/mni-perllib/perl/auto/MNI/Startup/self_announce.al)"
# ------------------------------ MNI Header ----------------------------------
#@NAME       : self_announce
#@INPUT      : $log     - [optional] filehandle to print announcement
#                         to; defaults to \*STDOUT
#              $program - [optional] program name to print instead of $0
#              $args    - [list ref; optional] program arguments to print
#                         instead of @ARGV
#@OUTPUT     : 
#@RETURNS    : 
#@DESCRIPTION: Prints the user, host, time, and full command line (as
#              supplied in @$args).  Useful for later figuring out
#              what happened from a log file.
#@METHOD     : 
#@GLOBALS    : $0, @ARGV
#@CREATED    : 
#@MODIFIED   : 
#-----------------------------------------------------------------------------
sub self_announce
{
   require MNI::MiscUtilities;
   my ($log, $program, $args, $force) = @_;

   croak "self_announce: if supplied, \$log must be an open filehandle"
      if defined $log && ! (ref $log && defined fileno($log));

   $log = \*STDOUT unless defined $log;
   $program = $0 unless defined $program;
   $args = \@ARGV unless defined $args;

   # don't do it if it would go to a terminal (unless we're forced to)
   my $suppress = $ENV{'suppress_announce'};
   delete $ENV{'suppress_announce'};
   return 
      if (-t fileno ($log) || $suppress) && !$force;
         

   printf $log ("[%s] [%s] running:\n", 
                MNI::MiscUtilities::userstamp (undef, undef, $StartDir),
                MNI::MiscUtilities::timestamp ());
   print $log "  $program " . MNI::MiscUtilities::shellquote (@$args) . "\n\n";
}

# end of MNI::Startup::self_announce
1;
